package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFCustomProcess;
import com.sa.ibiz.demo.demo.service.WFCustomProcessService;
import com.sa.ibiz.demo.demo.service.dto.WFCustomProcessSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfcustomprocess")
public class WFCustomProcessResource
{
	@Autowired
	private WFCustomProcessService service;


	@PostMapping(value = "/update")
	public ResponseEntity<WFCustomProcess> update(@Validated @RequestBody WFCustomProcess data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流预定义处理[update]操作发生错误","WFCustomProcess",data.getWfcustomprocessid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFCustomProcess> getDraft(@Validated @RequestBody WFCustomProcess data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流预定义处理[getDraft]操作发生错误","WFCustomProcess","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFCustomProcess> remove(@Validated @RequestBody WFCustomProcess data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流预定义处理[remove]操作发生错误","WFCustomProcess",data.getWfcustomprocessid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFCustomProcess> checkKey(@Validated @RequestBody WFCustomProcess data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流预定义处理[checkKey]操作发生错误","WFCustomProcess",data.getWfcustomprocessid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFCustomProcess> get(@Validated @PathVariable String id){
		WFCustomProcess data=new WFCustomProcess();
		data.setWfcustomprocessid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流预定义处理[get]操作发生错误","WFCustomProcess",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFCustomProcess> create(@Validated @RequestBody WFCustomProcess data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流预定义处理[create]操作发生错误","WFCustomProcess",data.getWfcustomprocessid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFCustomProcess>> searchDefaultPage(@Validated @RequestBody WFCustomProcessSearchFilter filter){
		Page<WFCustomProcess> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFCustomProcess>> listDefault(@Validated @RequestBody WFCustomProcessSearchFilter filter){
		List<WFCustomProcess> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
